
#include "ATtinyLoRa.h"
#include <avr/sleep.h>
#include <avr/wdt.h>
#include <SPI.h>

// recharger arduinoISP dans la UNO et réessayer

//#define SLEEP_TOTAL 37 // 37*8s = 296s ~5min
#define SLEEP_TOTAL 1 // 37*8s = 16s ~5min

// use your keys from TTN
uint8_t NwkSkey[16] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
uint8_t AppSkey[16] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
uint8_t DevAddr[4] = { 0x00, 0x00, 0x00, 0x00 };
// sleep cycles
volatile uint8_t sleep_count = 0;

// Global LoRaWan object
TinyLoRa lora;
const int pinLED = 9;
int cEmission = 0;


#pragma message "MOSI " PIN_SPI_MOSI


void setup()
{
  pinMode(pinLED, OUTPUT);
  Serial.begin( 115200);
  Serial.println( "init");
  Serial.println( PB2);
  digitalWrite(pinLED, LOW);
  
  // set slave select pins from RFM95 as outputs
  pinMode(NSS_RFM, OUTPUT);
  digitalWrite( NSS_RFM, HIGH);
    
  // Turn on the watch dog timer
  watchdogOn();

  SPI.begin();
  
  // init LoRa
  lora.begin();
  
  SPI.end();

  Serial.print( "portD"); Serial.println( PORTD, BIN);Serial.flush();
  digitalWrite(pinLED, HIGH);
}

void loop()
{
  //Disable ADC 
  ADCSRA &= ~(1<<ADEN); 
  
  goToSleep();

  if (sleep_count >= SLEEP_TOTAL) { 

    Serial.print( cEmission );

    cEmission++;
   
    digitalWrite(pinLED, LOW);

    SPI.begin();
      
    unsigned char Data[7] = "coucou";
    
    lora.sendData(Data, sizeof(Data), lora.frameCounter);
    lora.frameCounter++;
    
    // reset sleep count
    sleep_count = 0;

    Serial.print( "reg40 = "); Serial.println( lora.RFM_Read( 0x40));
    Serial.print( "portD"); Serial.println( PORTD, BIN);Serial.flush();
  

    SPI.end();
    
    // set DO, SCK as input and low prevents current draw in sleep mode.
    DDRB &= ~((1 << PB1) | (1 << PB2));
    PORTB &= ~((1 << PB0) | (1 << PB1) | (1 << PB2));
  }
}

void watchdogOn() {
  // clear various "reset" flags
  MCUSR = 0;
  // allow changes, disable reset
  WDTCSR = (1 << WDCE) | (1 << WDE);
  // set interrupt mode and an interval 
  WDTCSR = (1 << WDIE) | (1 << WDP3) | (1 << WDP0); // set WDIE, and 8 seconds delay
  wdt_reset();  // pat the dog
}

void goToSleep() {
  // Set sleep mode.
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
  sleep_enable();
  // Enter sleep mode.
  sleep_cpu();
  // After waking from watchdog interrupt the code continues from this point.
  
  // Disable sleep mode after waking.
  sleep_disable();
}

ISR(WDT_vect) {
  sleep_count++; // keep track of how many sleep cycles have been completed.
  //digitalWrite(pinLED, sleep_count % 2);
}
